Index: /pjproject/trunk/build/rules.mak
===================================================================
--- /pjproject/trunk/build/rules.mak	(revision 354)
+++ /pjproject/trunk/build/rules.mak	(revision 355)
@@ -154,5 +154,5 @@
 	for F in $(FULL_SRCS); do \
 	   if test -f $$F; then \
-	     echo -n "$(OBJDIR)/" >> $(DEP_FILE); \
+	     echo "$(OBJDIR)/" | tr -d '\n' >> $(DEP_FILE); \
 	     if gcc -M $(DEPFLAGS) $$F | sed '/^#/d' >> $(DEP_FILE); then \
 		true; \
Index: /pjproject/trunk/configure
===================================================================
--- /pjproject/trunk/configure	(revision 354)
+++ /pjproject/trunk/configure	(revision 355)
@@ -9,5 +9,5 @@
 fi;
 
-if echo $MACHINE | grep sun4u > /dev/null; then
+if echo $MACHINE | grep sparc > /dev/null; then
     MACHINE_NAME=sparc
 elif echo $MACHINE | grep i.86 > /dev/null; then
Index: /pjproject/trunk/pjlib-util/build/Makefile
===================================================================
--- /pjproject/trunk/pjlib-util/build/Makefile	(revision 354)
+++ /pjproject/trunk/pjlib-util/build/Makefile	(revision 355)
@@ -72,5 +72,5 @@
 	$(MAKE) -f $(RULES_MAK) APP=PJLIB_UTIL app=pjlib-util $@
 	$(MAKE) -f $(RULES_MAK) APP=UTIL_TEST app=pjlib-util-test $@
-	@if test "$@" == "depend"; then \
+	@if test "$@" = "depend"; then \
 	  echo '$(TEST_EXE): $(PJLIB_UTIL_LIB)' >> .pjlib-util-test-$(MACHINE_NAME)-$(OS_NAME)-$(CC_NAME).depend; \
 	fi
Index: /pjproject/trunk/pjmedia/build/Makefile
===================================================================
--- /pjproject/trunk/pjmedia/build/Makefile	(revision 354)
+++ /pjproject/trunk/pjmedia/build/Makefile	(revision 355)
@@ -161,5 +161,5 @@
 	$(MAKE) -f $(RULES_MAK) APP=PJMEDIA_TEST app=pjmedia-test $@
 	$(MAKE) -f $(RULES_MAK) APP=PJMEDIA_CODEC app=pjmedia-codec $@
-	@if test "$@" == "depend"; then \
+	@if test "$@" = "depend"; then \
 	  echo '$(PJMEDIA_LIB): .pjmedia-$(MACHINE_NAME)-$(OS_NAME)-$(CC_NAME).depend' >> .pjmedia-$(MACHINE_NAME)-$(OS_NAME)-$(CC_NAME).depend; \
 	  echo '$(PJMEDIA_CODEC_LIB): .pjmedia-codec-$(MACHINE_NAME)-$(OS_NAME)-$(CC_NAME).depend' >> .pjmedia-codec-$(MACHINE_NAME)-$(OS_NAME)-$(CC_NAME).depend; \
Index: /pjproject/trunk/pjmedia/build/os-win32.mak
===================================================================
--- /pjproject/trunk/pjmedia/build/os-win32.mak	(revision 354)
+++ /pjproject/trunk/pjmedia/build/os-win32.mak	(revision 355)
@@ -14,6 +14,7 @@
 
 # Example:
-#  to activate Null sound, uncomment this line below.
+#  to activate Null sound, uncomment these two lines below.
 #export SOUND_OBJS = $(NULLSOUND_OBJS)
+#export OS_CFLAGS += $(CC_DEF)PJMEDIA_HAS_NULL_SOUND
 
 # Example:
Index: /pjproject/trunk/pjmedia/include/pjmedia.h
===================================================================
--- /pjproject/trunk/pjmedia/include/pjmedia.h	(revision 354)
+++ /pjproject/trunk/pjmedia/include/pjmedia.h	(revision 355)
@@ -39,4 +39,5 @@
 #include <pjmedia/sdp.h>
 #include <pjmedia/sdp_neg.h>
+#include <pjmedia/silencedet.h>
 #include <pjmedia/session.h>
 #include <pjmedia/sound.h>
Index: /pjproject/trunk/pjmedia/include/pjmedia/silencedet.h
===================================================================
--- /pjproject/trunk/pjmedia/include/pjmedia/silencedet.h	(revision 354)
+++ /pjproject/trunk/pjmedia/include/pjmedia/silencedet.h	(revision 355)
@@ -131,5 +131,12 @@
 
 
+/**
+ * Declaration linear2ulaw
+ */
+unsigned char linear2ulaw(int pcm_val);
+
+
 PJ_END_DECL
+
 
 #endif	/* __PJMEDIA_SILENCE_DET_H__ */
Index: /pjproject/trunk/pjmedia/src/pjmedia/errno.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/errno.c	(revision 354)
+++ /pjproject/trunk/pjmedia/src/pjmedia/errno.c	(revision 355)
@@ -146,4 +146,5 @@
 
     /* See if the error comes from PortAudio. */
+#if defined(PJMEDIA_HAS_PORTAUDIO_SOUND) && PJMEDIA_HAS_PORTAUDIO_SOUND!=0
     if (statcode >= PJMEDIA_ERRNO_FROM_PORTAUDIO(paNotInitialized) &&
 	statcode <  PJMEDIA_ERRNO_FROM_PORTAUDIO(paNotInitialized + 10000))
@@ -160,5 +161,7 @@
 	return errstr;
 
-    } else if (statcode >= PJMEDIA_ERRNO_START && 
+    } else 
+#endif	/* PJMEDIA_HAS_PORTAUDIO_SOUND */
+    if (statcode >= PJMEDIA_ERRNO_START && 
 	       statcode < PJMEDIA_ERRNO_START + PJ_ERRNO_SPACE_SIZE)
     {
Index: /pjproject/trunk/pjsip-apps/build/Makefile
===================================================================
--- /pjproject/trunk/pjsip-apps/build/Makefile	(revision 354)
+++ /pjproject/trunk/pjsip-apps/build/Makefile	(revision 355)
@@ -93,5 +93,5 @@
 	$(MAKE) -f $(RULES_MAK) APP=PJSIPPERF app=pjsip-perf $@
 	$(MAKE) -f Samples.mak $@
-	@if test "$@" == "depend"; then \
+	@if test "$@" = "depend"; then \
 	  echo '$(PJSUA_EXE): $(PJSIP_LIB) $(PJSIP_UA_LIB) $(PJSIP_SIMPLE) $(PJSUA_LIB_LIB) $(PJLIB_LIB) $(PJLIB_UTIL_LIB) $(PJMEDIA_LIB) $(PJMEDIA_CODEC_LIB) Makefile' >> .pjsua-$(MACHINE_NAME)-$(OS_NAME)-$(CC_NAME).depend; \
 	  echo '$(PJSIPPERF_EXE): $(PJSIP_LIB) $(PJSIP_UA_LIB) $(PJSIP_SIMPLE) $(PJSUA_LIB_LIB) $(PJLIB_LIB) $(PJLIB_UTIL_LIB) $(PJMEDIA_LIB) $(PJMEDIA_CODEC_LIB)' >> .pjsip-perf-$(MACHINE_NAME)-$(OS_NAME)-$(CC_NAME).depend; \
Index: /pjproject/trunk/pjsip-apps/src/pjsua/main.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/main.c	(revision 354)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/main.c	(revision 355)
@@ -318,5 +318,5 @@
 
     /* Left trim */
-    while (isspace(*buf)) {
+    while (pj_isspace(*buf)) {
 	++buf;
 	--len;
@@ -330,5 +330,5 @@
 	return;
 
-    if (isdigit(*buf) || *buf=='-') {
+    if (pj_isdigit(*buf) || *buf=='-') {
 	
 	int i;
@@ -340,5 +340,5 @@
 
 	for (; i<len; ++i) {
-	    if (!isdigit(buf[i])) {
+	    if (!pj_isdigit(buf[i])) {
 		puts("Invalid input");
 		return;